VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmFileComm 
   Caption         =   "File Communications"
   ClientHeight    =   1365
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7785
   LinkTopic       =   "Form1"
   ScaleHeight     =   1365
   ScaleWidth      =   7785
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnReceive 
      Caption         =   "Receive"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6420
      TabIndex        =   5
      Top             =   540
      Width           =   1335
   End
   Begin VB.CommandButton btnSetOutput 
      Caption         =   "Set Output"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1500
      TabIndex        =   4
      Top             =   900
      Width           =   1335
   End
   Begin VB.CommandButton btnSetInput 
      Caption         =   "Set Input"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   900
      Width           =   1335
   End
   Begin VB.TextBox txtIn 
      Height          =   315
      Left            =   120
      TabIndex        =   2
      Top             =   540
      Width           =   6255
   End
   Begin VB.TextBox txtOut 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   6255
   End
   Begin VB.CommandButton btnSend 
      Caption         =   "Send"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6420
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
   Begin MSComDlg.CommonDialog cdlFile 
      Left            =   2880
      Top             =   840
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
End
Attribute VB_Name = "frmFileComm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Instance of file communications class
Private mFileComm As New clsFileComm

Private Sub btnSetInput_Click()
    ' Set the input file.
    On Error GoTo btnSetInput_ClickErrorHandler
    
    With cdlFile
        .FileName = mFileComm.InFile
        .DialogTitle = "Please enter the input file for communications"
        .Filter = "All Files (*.*)|*.*"
        .ShowOpen
        mFileComm.InFile = .FileName
    End With
    
    Exit Sub
'______________________
btnSetInput_ClickErrorHandler:
    Select Case Err.Number
    Case cdlCancel
        ' Do nothing if cancelled
    Case Else
        MsgBox "Error (frmFileComm - btnSetInput) " & CStr(Err.Number) & ": " & Err.Description
    End Select
End Sub

Private Sub btnSetOutput_Click()
    ' Set the output file.
    On Error GoTo btnSetOutput_ClickErrorHandler
    
    With cdlFile
        .FileName = mFileComm.OutFile
        .DialogTitle = "Please enter the output file for communications"
        .Filter = "All Files (*.*)|*.*"
        .ShowOpen
        mFileComm.OutFile = .FileName
    End With
    
    Exit Sub
'______________________
btnSetOutput_ClickErrorHandler:
    Select Case Err.Number
    Case cdlCancel
        ' Do nothing if cancelled
    Case Else
        MsgBox "Error (frmFileComm - btnSetOutput) " & CStr(Err.Number) & ": " & Err.Description
    End Select
End Sub

Private Sub btnSend_Click()
    ' Send data to the output file.
    mFileComm.SendData txtOut.Text
End Sub

Private Sub btnReceive_Click()
    ' Get data from the communications file.
    Dim strData As String
    
    mFileComm.GetData strData
    txtIn.Text = strData
    
End Sub

