VERSION 5.00
Begin VB.Form frmStates 
   Caption         =   "VI State Diagram Tester"
   ClientHeight    =   1695
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5895
   LinkTopic       =   "Form1"
   ScaleHeight     =   1695
   ScaleWidth      =   5895
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtStateLevel2 
      Height          =   315
      Left            =   1560
      TabIndex        =   8
      Top             =   1320
      Width           =   4275
   End
   Begin VB.TextBox txtStateLevel1 
      Height          =   315
      Left            =   1560
      TabIndex        =   7
      Top             =   960
      Width           =   4275
   End
   Begin VB.CommandButton btnAbort 
      Caption         =   "Abort"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4800
      TabIndex        =   5
      Top             =   480
      Width           =   1035
   End
   Begin VB.CommandButton btnResume 
      Caption         =   "Resume"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3720
      TabIndex        =   4
      Top             =   480
      Width           =   1035
   End
   Begin VB.CommandButton btnPause 
      Caption         =   "Pause"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   480
      Width           =   1035
   End
   Begin VB.CommandButton btnAnalyze 
      Caption         =   "Analyze"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1560
      TabIndex        =   2
      Top             =   480
      Width           =   1035
   End
   Begin VB.CommandButton btnOff 
      Caption         =   "Off"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2640
      TabIndex        =   1
      Top             =   60
      Width           =   1035
   End
   Begin VB.CommandButton btnOn 
      Caption         =   "On"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      Top             =   60
      Width           =   1035
   End
   Begin VB.Label lblCommands 
      Caption         =   "Commands:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label lblStateLevel2 
      Caption         =   "State Level 2:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   1320
      Width           =   1335
   End
   Begin VB.Label lblStateLevel1 
      Caption         =   "State Level 1:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   960
      Width           =   1335
   End
End
Attribute VB_Name = "frmStates"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' State Variables and Constants
Private Enum enumStateLevel1                ' Level 1 states
    conStateOff
    conStateOn
End Enum

Private Enum enumStateLevel2                ' Level 2 states
    conStateIdle
    conStatePaused
    conStateAnalyzing
End Enum

Private mStateLevel1 As enumStateLevel1     ' Level 1 state variable
Private mStateLevel2 As enumStateLevel2     ' Level 2 state variable

Private Sub Form_Load()
    ' Initialize state variables and interface
    mStateLevel1 = conStateOff
    UpdateInterface
End Sub

Private Sub ProcessCommand(strCommand As String)
    ' Process a command and take appropriate action.
    
    ' Select actions based on Level 1 state
    Select Case mStateLevel1
    
    Case conStateOff                        ' When the VI is off ...
    
        Select Case strCommand
        
        Case "ON"                           ' If an ON command is received ...
            mStateLevel1 = conStateOn
            mStateLevel2 = conStateIdle
            
            ' *** Insert appropriate commands here ***
            
        Case Else
            ' Do nothing when anything else is received while the VI is off
        
        End Select
        
    Case conStateOn                         ' When the VI is on ...
        
        Select Case strCommand
                                            ' No matter what the Level 2 state ...
        Case "OFF"                          ' if an OFF command is received, turn the instrument off.
            mStateLevel1 = conStateOff
        
            ' *** Insert appropriate commands here
        
        Case Else
        
            ' Select actions based on Level 2 state
            Select Case mStateLevel2
            
            Case conStateIdle               ' When the VI is idle ...
            
                Select Case strCommand
                
                Case "ANALYZE"              ' If an ANALYZE command is received ...
                    mStateLevel2 = conStateAnalyzing
                
                    ' *** Insert appropriate commands here
                      
                Case "ABORT", "PAUSE"       ' If an ABORT or PAUSE command is received ...
                    mStateLevel2 = conStateIdle
                    
                    ' *** Insert appropriate commands here
                
                Case Else                   ' Otherwise issue an error.
                    MsgBox "Invalid command while idle: " & strCommand
                
                End Select
            
            Case conStateAnalyzing          ' While the VI is analyzing ...
            
                Select Case strCommand
                
                Case "ABORT"                ' If an ABORT command is received ...
                    mStateLevel2 = conStateIdle
                
                    ' *** Insert appropriate commands here
                
                Case "PAUSE"                ' If an PAUSE command is received ...
                    mStateLevel2 = conStatePaused
                    
                    ' *** Insert appropriate commands here
                
                Case Else                   ' Otherwise issue an error.
                    MsgBox "Invalid command while analyzing: " & strCommand
                
                End Select
            
            Case conStatePaused             ' While the VI is paused ...
            
                Select Case strCommand
                
                Case "ABORT"                ' If an ABORT command is received ...
                    mStateLevel2 = conStateIdle
                
                    ' *** Insert appropriate commands here
                
                Case "RESUME"               ' If a RESUME command is received ...
                    mStateLevel2 = conStateAnalyzing
                    
                    ' *** Insert appropriate commands here
                
                Case Else                   ' Otherwise issue an error.
                    MsgBox "Invalid command while paused: " & strCommand
                
                End Select
            
            Case Else
            
            End Select
        
        End Select
    End Select
    
    ' Update the interface
    UpdateInterface
    
End Sub

Private Sub btnAbort_Click()
    ProcessCommand "ABORT"
End Sub

Private Sub btnAnalyze_Click()
    ProcessCommand "ANALYZE"
End Sub

Private Sub btnOff_Click()
    ProcessCommand "OFF"
End Sub

Private Sub btnOn_Click()
    ProcessCommand "ON"
End Sub

Private Sub btnPause_Click()
    ProcessCommand "PAUSE"
End Sub

Private Sub btnResume_Click()
    ProcessCommand "RESUME"
End Sub

Private Sub UpdateInterface()
    ' Update the state display on the interface
    
    Select Case mStateLevel1
    Case conStateOff
        txtStateLevel1.Text = "Off"
        txtStateLevel2.Text = ""
        
    Case conStateOn
        txtStateLevel1.Text = "On"
        
        Select Case mStateLevel2
        Case conStateIdle:      txtStateLevel2.Text = "Idle"
        Case conStateAnalyzing: txtStateLevel2.Text = "Analyzing"
        Case conStatePaused:    txtStateLevel2.Text = "Paused"
        End Select
        
    End Select
    
End Sub
