VERSION 5.00
Begin VB.Form frmCommSettings 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Communication Settings"
   ClientHeight    =   2280
   ClientLeft      =   2820
   ClientTop       =   2520
   ClientWidth     =   3780
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2280
   ScaleWidth      =   3780
   ShowInTaskbar   =   0   'False
   Begin VB.CheckBox chkEnabled 
      Alignment       =   1  'Right Justify
      Caption         =   "Port Enabled:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   12
      Top             =   120
      Value           =   1  'Checked
      Width           =   1515
   End
   Begin VB.CommandButton btnCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2640
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2640
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
   Begin VB.ComboBox cmbCommPort 
      Height          =   315
      Left            =   1380
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   480
      Width           =   1155
   End
   Begin VB.ComboBox cmbBaudRate 
      Height          =   315
      Left            =   1380
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   840
      Width           =   1155
   End
   Begin VB.ComboBox cmbDataBits 
      Height          =   315
      Left            =   1380
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   1560
      Width           =   1155
   End
   Begin VB.ComboBox cmbParity 
      Height          =   315
      Left            =   1380
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   1200
      Width           =   1155
   End
   Begin VB.ComboBox cmbStopBits 
      Height          =   315
      Left            =   1380
      Style           =   2  'Dropdown List
      TabIndex        =   6
      Top             =   1920
      Width           =   1155
   End
   Begin VB.Label lblPortNumber 
      Alignment       =   1  'Right Justify
      Caption         =   "Port Number:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   11
      Top             =   480
      Width           =   1215
   End
   Begin VB.Label lblBaudRate 
      Alignment       =   1  'Right Justify
      Caption         =   "Baud Rate:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   10
      Top             =   840
      Width           =   1215
   End
   Begin VB.Label lblDataBits 
      Alignment       =   1  'Right Justify
      Caption         =   "Data Bits:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   9
      Top             =   1560
      Width           =   1215
   End
   Begin VB.Label lblStopBits 
      Alignment       =   1  'Right Justify
      Caption         =   "Stop Bits:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   8
      Top             =   1920
      Width           =   1215
   End
   Begin VB.Label lblParity 
      Alignment       =   1  'Right Justify
      Caption         =   "Parity:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   7
      Top             =   1200
      Width           =   1215
   End
End
Attribute VB_Name = "frmCommSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub ResetCommSettings()
    ' Build the Comm Settings string based on selections
    Dim strTmp As String, lngTmp As Long
    
    strTmp = ""
    
    ' Reset the flag indicating whether or not the port is to be enabled
    If chkEnabled.Value = vbChecked Then
        frmMain.CommEnabled = True
    Else
        frmMain.CommEnabled = False
    End If
    
    ' Reset Comm port parameter
    frmMain.CommPort = cmbCommPort.ItemData(cmbCommPort.ListIndex)
    
    ' Baud Rate
    strTmp = strTmp & CStr(cmbBaudRate.ItemData(cmbBaudRate.ListIndex))
    
    ' Parity
    strTmp = strTmp & "," & Chr$(cmbParity.ItemData(cmbParity.ListIndex))
    
    ' Data Bits
    strTmp = strTmp & "," & CStr(cmbDataBits.ItemData(cmbDataBits.ListIndex))
    
    ' Stop Bits
    strTmp = strTmp & "," & CStr(CSng(cmbStopBits.ItemData(cmbStopBits.ListIndex)) * 0.5)
    
    ' Reset Main Form settings parameter
    frmMain.CommSettings = strTmp
    
    ' Cause changes to take effect
    frmMain.ResetRS232Port
    
End Sub

Private Sub InitializeForm()
    ' Initialize the dropdown lists
    
    ' RS-232 Port
    With cmbCommPort
        .Clear
        .AddItem "Port 1":  .ItemData(.NewIndex) = 1
        .AddItem "Port 2":  .ItemData(.NewIndex) = 2
        .ListIndex = 0      ' Default to Port 1
    End With
    
    ' Baud Rate
    With cmbBaudRate
        .Clear
        .AddItem "1200":    .ItemData(.NewIndex) = 1200
        .AddItem "2400":    .ItemData(.NewIndex) = 2400
        .AddItem "9600":    .ItemData(.NewIndex) = 9600
        .AddItem "14400":   .ItemData(.NewIndex) = 14400
        .AddItem "19200":   .ItemData(.NewIndex) = 19200
        .ListIndex = 4      ' Default to 19200 BAUD
    End With

    ' Parity
    With cmbParity
        .Clear
        .AddItem "Even":    .ItemData(.NewIndex) = Asc("E")
        .AddItem "Mark":    .ItemData(.NewIndex) = Asc("M")
        .AddItem "None":    .ItemData(.NewIndex) = Asc("N")
        .AddItem "Odd":     .ItemData(.NewIndex) = Asc("O")
        .AddItem "Space":   .ItemData(.NewIndex) = Asc("S")
        .ListIndex = 2      ' Default to No Parity
    End With

    ' Data Bits
    With cmbDataBits
        .Clear
        .AddItem "4":       .ItemData(.NewIndex) = 4
        .AddItem "5":       .ItemData(.NewIndex) = 5
        .AddItem "6":       .ItemData(.NewIndex) = 6
        .AddItem "7":       .ItemData(.NewIndex) = 7
        .AddItem "8":       .ItemData(.NewIndex) = 8
        .ListIndex = 4      ' Default to 8 data bits
    End With

    ' Stop Bits
    With cmbStopBits
        .Clear
        .AddItem "1":       .ItemData(.NewIndex) = 2
        .AddItem "1.5":     .ItemData(.NewIndex) = 3
        .AddItem "2":       .ItemData(.NewIndex) = 4
        .ListIndex = 0      ' Default to 1 stop bit
    End With
    
End Sub

Private Sub btnCancel_Click()
    Hide
End Sub

Private Sub btnOK_Click()
    ' Reset the comm settings
    ResetCommSettings
    Hide
End Sub

Private Sub Form_Load()
    InitializeForm
End Sub
