VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form frmServer 
   Caption         =   "VB Multi-client Winsock Server"
   ClientHeight    =   825
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   825
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrData 
      Interval        =   1000
      Left            =   3720
      Top             =   60
   End
   Begin ComctlLib.StatusBar sbrMessage 
      Align           =   2  'Align Bottom
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Top             =   510
      Width           =   4680
      _ExtentX        =   8255
      _ExtentY        =   556
      Style           =   1
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.CommandButton btnListen 
      Caption         =   "Listen"
      Height          =   375
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   1155
   End
   Begin MSWinsockLib.Winsock sckServer 
      Index           =   0
      Left            =   4200
      Top             =   60
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   327681
   End
End
Attribute VB_Name = "frmServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Set the maximum number of allowable connections/controls
Const mConMaxConnections As Integer = 3

Private Sub btnListen_Click()
   ' Initialize the port on which to listen
    sckServer(0).LocalPort = 1234
    
    ' Start listening for a client connection request
    sckServer(0).Listen
    sbrMessage.SimpleText = "Listening ..."
End Sub

Private Sub sckServer_ConnectionRequest(Index As Integer, ByVal requestID As Long)
    ' Accept the connection on the next socket control in the control array
    Dim I As Integer, intIndex As Integer, strMsg As String, sck As Winsock
    
    ' Ignore request if not the server socket.
    If Index <> 0 Then Exit Sub
    
    ' Look for an available socket control index
    intIndex = 1
    For Each sck In sckServer
        ' Skip index 0 as this is the listening socket
        If sck.Index > 0 Then
            If intIndex < sck.Index Then Exit For
            intIndex = intIndex + 1
        End If
    Next sck
    
    ' If exceeded the maximum number of controls then exit.
    If intIndex > mConMaxConnections Then Exit Sub
    
    ' Load new control and accept connection
    Load sckServer(intIndex)
    sckServer(intIndex).LocalPort = 0
    sckServer(intIndex).Accept requestID

    ' Indicate status
    sbrMessage.SimpleText = "Socket " & CStr(intIndex) & " accepted a connection"
    
End Sub

Private Sub sckServer_DataArrival(Index As Integer, ByVal bytesTotal As Long)
    ' Collect data from network connection when it arrives
    Dim strData As String
    
    ' Exit if this is the listening socket.
    If Index = 0 Then Exit Sub
    
    ' Collect data
    sckServer(Index).GetData strData, vbString
    sbrMessage.SimpleText = "Socket " & CStr(Index) & " received: " & strData
    
    ' Echo back data sent.
    sckServer(Index).SendData strData
End Sub

Private Sub sckServer_Close(Index As Integer)
    
    ' If not the listening socket then ...
    If Index > 0 Then
        ' Make sure the connection is closed
        If sckServer(Index).State <> sckClosed Then sckServer(Index).Close
        ' Unload the control
        Unload sckServer(Index)
        sbrMessage.SimpleText = "Socket " & CStr(Index) & " - Connection closed"
    End If
    
End Sub

Private Sub tmrData_Timer()
    ' Broadcast data to all connected clients
    Dim sngData As Single, sck As Winsock
    
    sngData = Rnd       ' Generate a random number

    For Each sck In sckServer
        ' Send the data to all but the listening socket
        If sck.Index > 0 Then
            sck.SendData CStr(sngData) & vbCr
            DoEvents    ' Allow all clients to get data
        End If
    Next sck

End Sub
