VERSION 5.00
Object = "{02B5E320-7292-11CF-93D5-0020AF99504A}#2.0#0"; "MSCHRT20.OCX"
Begin VB.Form frmPlot 
   Caption         =   "Test Plot"
   ClientHeight    =   5430
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7635
   LinkTopic       =   "Form1"
   ScaleHeight     =   5430
   ScaleWidth      =   7635
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnPlotIt 
      Caption         =   "Plot It"
      Height          =   435
      Left            =   5940
      TabIndex        =   1
      Top             =   4980
      Width           =   1575
   End
   Begin MSChartLib.MSChart chtPlot 
      Height          =   4755
      Left            =   120
      OleObjectBlob   =   "Ex2.frx":0000
      TabIndex        =   0
      Top             =   120
      Width           =   7455
   End
End
Attribute VB_Name = "frmPlot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub btnPlotIt_Click()
    ' Add data to a plot one point at a time
    Dim I As Integer, X As Single
    Const conPi As Single = 3.14159
    
    With chtPlot
        .chartType = VtChChartType2dBar ' Set chart type
        
        .RowCount = 10                  ' Set number of data points
        .ColumnCount = 2                ' Two series of data
        
        .RowLabelCount = 2              ' Two levels of point labels
        
        For I = 1 To 10                 ' Generate points
            .Row = I
            .Column = 1                 ' X column
            X = CSng(I - 1) * 0.05 * conPi
            .Data = 10# * Sin(X)
            
            .RowLabelIndex = 1          ' First level point label
            .RowLabel = "Point " & CStr(I)
            If (I - 1) Mod 5 = 0 Then   ' Second level point label
                .RowLabelIndex = 2      ' for every five points
                .RowLabel = "Group " & CStr(I \ 5 + 1)
            End If
            
            .Column = 2                 ' Y column
            .Data = 10# * Sin(X) * Sin(X * 0.6)
        Next I
    End With
End Sub
