VERSION 5.00
Begin VB.Form frmCanvas 
   Caption         =   "CheckBox Lasso"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   11
      Left            =   3120
      TabIndex        =   11
      Top             =   1080
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   10
      Left            =   1020
      TabIndex        =   10
      Top             =   1080
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   9
      Left            =   1440
      TabIndex        =   9
      Top             =   1080
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   8
      Left            =   1860
      TabIndex        =   8
      Top             =   1080
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   7
      Left            =   2280
      TabIndex        =   7
      Top             =   1080
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   6
      Left            =   2700
      TabIndex        =   6
      Top             =   1080
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   5
      Left            =   3120
      TabIndex        =   5
      Top             =   600
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   4
      Left            =   2700
      TabIndex        =   4
      Top             =   600
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   3
      Left            =   2280
      TabIndex        =   3
      Top             =   600
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   2
      Left            =   1860
      TabIndex        =   2
      Top             =   600
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   1
      Left            =   1440
      TabIndex        =   1
      Top             =   600
      Width           =   255
   End
   Begin VB.CheckBox chkSelect 
      BackColor       =   &H00C0C0C0&
      Height          =   315
      Index           =   0
      Left            =   1020
      TabIndex        =   0
      Top             =   600
      Width           =   255
   End
End
Attribute VB_Name = "frmCanvas"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Variables to hold lasso coordinates
Private mIntX1 As Integer, mIntY1 As Integer, mIntX2 As Integer, mIntY2 As Integer

Private mBlnDrawing As Integer                  ' Current drawing mode

Private Sub Form_Load()
    Dim I As Integer
    
    ' Initialize Form graphics properties
    With frmCanvas
        .BackColor = vbWhite
        .DrawMode = vbInvert
        .DrawStyle = vbDot
    End With
    
    ' Set CheckBox background color to blend in with form
    For I = 0 To 11
        chkSelect(I).BackColor = vbWhite
    Next I
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    mBlnDrawing = True                          ' Initialize drawing
    mIntX1 = X: mIntY1 = Y                      ' Initialize points
    mIntX2 = X: mIntY2 = Y
    Line (mIntX1, mIntY1)-(mIntX2, mIntY2), , B ' Draw first lasso
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If mBlnDrawing = False Then Exit Sub        ' If not drawing then exit
    Line (mIntX1, mIntY1)-(mIntX2, mIntY2), , B ' Erase the last lasso
    mIntX2 = X: mIntY2 = Y                      ' Update saved points
    Line (mIntX1, mIntY1)-(mIntX2, mIntY2), , B ' Draw the new lasso
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Line (mIntX1, mIntY1)-(mIntX2, mIntY2), , B ' Erase the last lasso
    mBlnDrawing = False                         ' Exit drawing mode
    SelectItems
End Sub

Private Sub SelectItems()
    Dim I As Integer, intLeft As Integer, intTop As Integer
    Dim X1 As Integer, Y1 As Integer, X2 As Integer, Y2 As Integer
    
    If mIntX1 < mIntX2 Then                     ' Sort corners of lasso
        X1 = mIntX1:  X2 = mIntX2
    Else
        X1 = mIntX2:  X2 = mIntX1
    End If
    
    If mIntY1 < mIntY2 Then
        Y1 = mIntY1:  Y2 = mIntY2
    Else
        Y1 = mIntY2:  Y2 = mIntY1
    End If
    
    ' Select all CheckBoxes that fall in lasso
    For I = 0 To 11
        intLeft = chkSelect(I).Left             ' Save position of CheckBox
        intTop = chkSelect(I).Top
                                                ' Set CheckBox value
        If X1 < intLeft And X2 > intLeft And Y1 < intTop And Y2 > intTop Then
                chkSelect(I).Value = vbChecked
        End If
    Next I

End Sub
