VERSION 5.00
Begin VB.Form frmKnob 
   Caption         =   "Knob"
   ClientHeight    =   2670
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4080
   LinkTopic       =   "Form1"
   ScaleHeight     =   2670
   ScaleWidth      =   4080
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnSet 
      Caption         =   "Set"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2760
      TabIndex        =   3
      Top             =   2280
      Width           =   1215
   End
   Begin VB.TextBox txtValue 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   2280
      Width           =   1455
   End
   Begin VB.PictureBox pctCanvas 
      Height          =   2115
      Left            =   120
      ScaleHeight     =   2055
      ScaleWidth      =   3795
      TabIndex        =   0
      Top             =   120
      Width           =   3855
   End
   Begin VB.Label lblValue 
      Caption         =   "Value"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1620
      TabIndex        =   2
      Top             =   2340
      Width           =   675
   End
End
Attribute VB_Name = "frmKnob"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Module-level variable to hold reference for Knob object
Private WithEvents mKnob As Knob
Attribute mKnob.VB_VarHelpID = -1

Private Sub Form_Load()
    ' Create and initialize the new knob class
    Set mKnob = New Knob
    Set mKnob.PictureBox = pctCanvas
End Sub

Private Sub btnSet_Click()
    ' Change the knob setting to appropriate value
    If IsNumeric(txtValue.Text) Then mKnob.Value = CSng(txtValue.Text)
End Sub

Private Sub mKnob_Change(ByVal sngValue As Single)
    ' When the value changes, automatically reflect in the text box
    txtValue.Text = CInt(sngValue)
End Sub

