VERSION 5.00
Begin VB.Form frmNetworkSettings 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Network Settings"
   ClientHeight    =   900
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3780
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   900
   ScaleWidth      =   3780
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtServerPort 
      Height          =   315
      Left            =   1440
      TabIndex        =   4
      Text            =   "1234"
      Top             =   420
      Width           =   915
   End
   Begin VB.CommandButton btnOK 
      Caption         =   "OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2640
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton btnCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2640
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.CheckBox chkEnabled 
      Alignment       =   1  'Right Justify
      Caption         =   "Connection Enabled:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Value           =   1  'Checked
      Width           =   2235
   End
   Begin VB.Label lblServerPort 
      Caption         =   "Server Port:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   1155
   End
End
Attribute VB_Name = "frmNetworkSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub ResetNetworkSettings()
    
    ' Reset the flag indicating whether or not the network connection is to be enabled
    If chkEnabled.Value = vbChecked Then
        frmMain.NetworkEnabled = True
    Else
        frmMain.NetworkEnabled = False
    End If
    
    ' Reset the server port on which to listen
    If IsNumeric(txtServerPort.Text) Then frmMain.ServerPort = CInt(txtServerPort.Text)
    
    ' Cause changes to take effect
    frmMain.ResetNetworkConnection
End Sub

Private Sub btnCancel_Click()
    Hide
End Sub

Private Sub btnOK_Click()
    ' Reset the network settings
    ResetNetworkSettings
    Hide
End Sub


Private Sub Form_Load()
    ' Upon loading set the interface to reflect the current parameter settings
    If frmMain.NetworkEnabled = True Then
        chkEnabled.Value = vbChecked
    Else
        chkEnabled.Value = vbUnchecked
    End If
    
    txtServerPort.Text = CStr(frmMain.ServerPort)
    
End Sub

